<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Filter View editor</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_Config.html">Customization</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Filter View editor </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The panel for editing <a class="el" href="pageUsingAS.html#secFilterViews">filter views</a> is opened when "Edit Filter Views..." is selected from <a class="el" href="page_Config.html#pictureSettingsMenu">the menu</a>.</p>
<p>The panel may look rather complex, but it consists of several parts, each of them relatively simple and clear:</p>
<p><a class="anchor" id="anchor_FilterViewEditorPanel"></a></p><div class="image">
<img src="filterViewEditor.png" alt=""/>
<div class="caption">
The Filter View editor panel</div></div>
 <p>Let us cover the numbered areas of the panel one by one, as it should make the logic of the entire panel clear.</p>
<h1><a class="anchor" id="sec_FilterVewEditorName"></a>
1. Select/create/rename</h1>
<p>Several configurations of the filter view area can be created. The upper part of the panel is used to select previously created configurations for editing, or to create a new configuration:</p>
<div class="image">
<img src="filterViewName.png" alt=""/>
<div class="caption">
Select/create configuration for editing</div></div>
 <p>The name of the selected filter view configuration can be changed using the text field located next to the <b>New</b> button.</p>
<p>The <b>Delete</b> button on the right can be used to delete the selected filter view configuration.</p>
<h1><a class="anchor" id="sec_FilterViewEditorTexts"></a>
2. Text templates for items</h1>
<p>The rule for building the strings displayed in items (widgets) of the <a class="el" href="pageUsingAS.html#secFilterViews">filter view</a>, is configure per-view. The string may contain the name of filter, plus some statistics, like the total number of alarms matching the filter or the number of unacknowledged alarms.</p>
<p>The second area of the Filter View editor is used to edit the text templates used to build item and tooltip texts for all items in the filter view:</p>
<div class="image">
<img src="filterViewTexts.png" alt=""/>
<div class="caption">
Edit text templates for filter view items</div></div>
 <p>Both format strings are built using the same rules. The template strings contains two types of elements: </p><ul>
<li>
'Literal' characters that are copied to the resulting string, and  </li>
<li>
filter statistics names that will be substituted with the corresponding values calculated for the filter.  </li>
</ul>
<p>The following names are supported:</p>
<p><a class="anchor" id="anchor_FilterViewValueSpecs"></a></p><table class="doxtable">
<tr>
<th>Name </th><th>Description  </th></tr>
<tr>
<td>%{name} </td><td>The name of filter  </td></tr>
<tr>
<td>%{total} </td><td>Number of alarms matching this filter  </td></tr>
<tr>
<td>%{totalBg} </td><td>Background color of 'the most severe' alarm matching this filter  </td></tr>
<tr>
<td>%{totalFg} </td><td>Foreground color of 'the most severe' alarm matching this filter  </td></tr>
<tr>
<td>%{totalTime} </td><td>Time of the latest alarm matching this filter  </td></tr>
<tr>
<td>%{came} </td><td>Total number of CAME alarms matching this filter  </td></tr>
<tr>
<td>%{cameBg} </td><td>Background color of 'the most severe' CAME alarm matching this filter  </td></tr>
<tr>
<td>%{cameFg} </td><td>Foreground color of 'the most severe' CAME alarm matching this filter  </td></tr>
<tr>
<td>%{cameTime} </td><td>Time of the latest CAME alarm matching this filter  </td></tr>
<tr>
<td>%{went} </td><td>Total number of WENT alarms matching this filter  </td></tr>
<tr>
<td>%{wentBg} </td><td>Background color of 'the most severe' WENT alarm matching this filter  </td></tr>
<tr>
<td>%{wentFg} </td><td>Foreground color of 'the most severe' WENT alarm matching this filter  </td></tr>
<tr>
<td>%{wentTime} </td><td>Time of the latest WENT alarm matching this filter  </td></tr>
<tr>
<td>%{notAck} </td><td>Total number of not acknowledged alarms matching this filter  </td></tr>
<tr>
<td>%{notAckBg} </td><td>Background color of 'the most severe' not acknowledged alarm matching this filter  </td></tr>
<tr>
<td>%{notAckFg} </td><td>Foreground color of 'the most severe' not acknowledged alarm matching this filter  </td></tr>
<tr>
<td>%{notAckTime} </td><td>Time of the latest not acknowledged alarm matching this filter  </td></tr>
<tr>
<td>%{new} </td><td>Total number of 'new' alarms matching this filter. An alarm is 'new' if its direction is CAME <b>and</b> its comment is empty.   </td></tr>
<tr>
<td>%{newBg} </td><td>Background color of 'the most severe' new alarm matching this filter  </td></tr>
<tr>
<td>%{newFg} </td><td>Foreground color of 'the most severe' new alarm matching this filter  </td></tr>
<tr>
<td>%{newTime} </td><td>Time of the latest new alarm matching this filter  </td></tr>
</table>
<p>'The most severe' alarm, mentioned in the table above, is found using the following rules (applied in this order): </p><ul>
<li>
Alarms with higher priority are more severe than alarms with lower priority  </li>
<li>
CAME alarms are more severe than WENT alarms  </li>
<li>
Not acknowledged alarms are more severe than acknowledged alarms  </li>
</ul>
<p>If more than one 'most severe' alarm is found after applying all the rules, then one of them is selected randomly to be 'the most severe' alarm.</p>
<p>The combo box on the right side of this area acts as a helper for selecting one of the supported names: selecting an item in the combo box copies its text to the clipboard, and then it can be inserted to into the text field by using <b>Ctrl+V</b>.</p>
<p>Here are some examples of format strings:</p>
<ul>
<li>
Simple text with the filter name followed by a comma and the total number of alarms matching the filter: <div class="fragment"><div class="line">%{name}: %{total}</div>
</div><!-- fragment --> This template will be rendered as (for a filter named 'na62dcs01', with 1234 alarms matching the filter): <div class="fragment"><div class="line">na62dcs01: 1234</div>
</div><!-- fragment -->  </li>
<li>
Another simple example: in addition to the total number of matching alarms, we want to also display the number of unacknowledged alarms matching the filter: <div class="fragment"><div class="line">%{name}: %{total} (%{notAck})</div>
</div><!-- fragment --> This template will be rendered as (filter from the previous example, there are 456 unacknowledged alarms): <div class="fragment"><div class="line">na62dcs01: 1234 (456)</div>
</div><!-- fragment -->  </li>
<li>
A more advanced example: rich text formatting is also supported. We want the strings to be rendered as in the previous example, but the number of unacknowledged alarms should appear in a <b>bold</b> font on a background corresponding to the background color of the most severe unacknowledged alarm: <div class="fragment"><div class="line">&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;p align=&quot;center&quot;&gt;%{name}: %{total} (&lt;span style=&quot;font-weight:600;color:%{notAckFg};background-color:%{notAckBg}&quot;&gt;%{notAck}&lt;/span&gt;)&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</div>
</div><!-- fragment --> This template will result in the following appearance of the items in the Filter View: <div class="image">
<img src="filterViewRichText.png" alt=""/>
<div class="caption">
Rich text example</div></div>
   </li>
</ul>
<h1><a class="anchor" id="sec_FilterViewAvailableFilters"></a>
3. Available filter names</h1>
<p>The table in the area #3 of <a class="el" href="page_FilterViewEditor.html#anchor_FilterViewEditorPanel">the filter view editor</a> lists the names of all filters <a class="el" href="pageUsingAS.html#pictureSaveFilter">saved</a> in the current project. Note that <b>all</b> filters are shown in the table, not only the filters saved by the current user:</p>
<div class="image">
<img src="filterViewAvailableFilters.png" alt=""/>
<div class="caption">
List of available filters</div></div>
 <p>Filters can be dragged from the table to the <a class="el" href="page_FilterViewEditor.html#sec_FilterViewBuild">content table</a> in order to build the contents the filter view.</p>
<h1><a class="anchor" id="sec_FilterViewAppearance"></a>
4. Appearance</h1>
<p>The controls in the area #4 of <a class="el" href="page_FilterViewEditor.html#anchor_FilterViewEditorPanel">the filter view editor</a> are used to customize the appearance of both the filter view area and items in it:</p>
<div class="image">
<img src="filterViewAppearance.png" alt=""/>
<div class="caption">
Customizing the appearance of the view and items</div></div>
 <p>The controls in this area of panel are grouped into two columns: </p><ul>
<li>
The 'Frame' column is used to configure the appearance for the whole Filter View.  </li>
<li>
The 'Item (filter)' column is used to customize the appearance of individual items (filters) in the Filter View.  </li>
</ul>
<p>The results of the changes in this area can be immediately observed in the <a class="el" href="page_FilterViewEditor.html#sec_FilterViewBuild">area #5</a> of the Filter View editor. Most of the settings fall into the category should be self-explanatory and achieving the desired look &amp; feel is easy thanks to the preview.</p>
<p>Two additional widgets are located in the lower right corner in the picture above and allow to select sources of colors used in the items (see <a class="el" href="page_FilterViewEditor.html#anchor_FilterViewValueSpecs">the table</a>).</p>
<h1><a class="anchor" id="sec_FilterViewBuild"></a>
5. Content and preview</h1>
<p>The area #5 of <a class="el" href="page_FilterViewEditor.html#anchor_FilterViewEditorPanel">the filter view editor</a> is used to build the contents of the filter view by adding and moving individual filters.</p>
<div class="image">
<img src="filterViewBuild.png" alt=""/>
<div class="caption">
Building the filter view</div></div>
 <p>This area contains three main widgets:</p>
<ul>
<li>
The radio box in the upper left corner is used to configure the orientation of the Filter View (horizontal/vertical).<br  />
 The orientation should be selected according to the planned position of the Filter View in the AS EWO: <ul>
<li>
Horizontal orientation should be used if it will be placed above or below the alarm table.  </li>
<li>
Vertical orientation should be used if it will be placed on the left or right of the alarm table.  </li>
</ul>
</li>
<li>
The table where individual filters are placed according to the desired position of these filters in the resulting Filter View. <ul>
<li>
Cells with yellow background are already occupied and the name of filter is displayed in them.  </li>
<li>
Cells with green background are 'free' and filters can be placed in them.  </li>
</ul>
The main editing method of the Filter View content is based on drag-and-drop: dragging the filters from the <a class="el" href="page_FilterViewEditor.html#sec_FilterViewAvailableFilters">list of available filters</a>, or dragging filters between the cells of this table.  </li>
<li>
The preview area where the user can see how the resulting Filter View will look like. This preview area is <b>not</b> connected to any alarms, so all counters are set to 0 and default colors are used.  </li>
</ul>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
